package com.ruoyi.app.mapper;

import java.util.Date;
import java.util.List;

import com.ruoyi.app.DTO.PorkProduceDTO;
import com.ruoyi.app.DTO.ProductionVo;
import com.ruoyi.app.DTO.SlaughterBatchDTO;
import com.ruoyi.app.DTO.SlaughterReportDTO;
import com.ruoyi.app.model.SlaughterBatch;
import com.ruoyi.app.model.request.*;
import com.ruoyi.app.model.response.*;
import org.apache.ibatis.annotations.Param;

/**
 * 屠宰批次Mapper接口
 * 
 * @author coede
 * @date 2025-03-19
 */
public interface SlaughterBatchMapper 
{
    /**
     * 查询屠宰批次
     * 
     * @param id 屠宰批次主键
     * @return 屠宰批次
     */
    public SlaughterBatchDTO selectSlaughterBatchById(Long id);

    /**
     * 查询屠宰批次列表
     * 
     * @param slaughterBatch 屠宰批次
     * @return 屠宰批次集合
     */
    public List<SlaughterBatchDTO> selectSlaughterBatchList(ReqSlaughterBatch slaughterBatch);

    /**
     * 新增屠宰批次
     * 
     * @param slaughterBatch 屠宰批次
     * @return 结果
     */
    public int insertSlaughterBatch(SlaughterBatch slaughterBatch);

    /**
     * 修改屠宰批次
     * 
     * @param slaughterBatch 屠宰批次
     * @return 结果
     */
    public int updateSlaughterBatch(SlaughterBatch slaughterBatch);

    /**
     * 删除屠宰批次
     * 
     * @param id 屠宰批次主键
     * @return 结果
     */
    public int deleteSlaughterBatchById(Long id);

    /**
     * 批量删除屠宰批次
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSlaughterBatchByIds(Long[] ids);

    public int deleteSlaughterBatchByDistributeId(Long id);

    public int deleteSlaughterBatchByDistributeIds(Long[] ids);

    /**
     * 根据入场批次和分销批次ID获取各部位称重记录
     *
     * @param  reqEntranceAndDistribute 入场和分销批次信息
     * @return 结果
     */
    public List<PorkProduceDTO> selectPorkProduceByBatch(ReqEntranceAndDistribute reqEntranceAndDistribute);

    /**
     * 查询屠宰批次列表
     *
     * @param reqSlaughterReport 查询条件
     * @return 屠宰批次集合
     */
    public List<SlaughterReportDTO> selectSlaughterReport(ReqSlaughterReport reqSlaughterReport);


    List<ProductionVo> getAllList(@Param("entranceBatchId")Long entranceBatchId,@Param("purchaserId")Long purchaserId);

    /**
     * 生猪屠宰情况日汇总表  2025-10-09
     *
     * @param req 查询条件
     * @return 集合
     */
    public List<GetDailySlaughterReportResp> selectDailySlaughterReport(GetDailySlaughterReportReq req);

    /**
     * 生猪入场查验情况表  2025-10-15
     *
     * @param req 查询条件
     * @return 集合
     */
    public List<GetDailyEntranceReportResp> selectDailyEntranceReport(GetDailyEntranceReportReq req);

    /**
     * 违禁药物检测及屠宰检验情况表  2025-10-10
     *
     * @param req 查询条件
     * @return 集合
     */
    public List<GetDailyDrugCheckAndSlaughterReportResp> selectDailyDrugCheckAndSlaughterReport(GetDailyDrugCheckAndSlaughterReportReq req);

    /**
     * 违禁药物检测详情 2025-10-10
     *
     *
     * @return 集合
     */
    public DrugCheckDTO getDrug(@Param("entranceBatchId") Long entranceBatchId, @Param("checkType") String checkType);

    /**
     * 生猪屠宰环节无害化处理表  2025-10-11
     *
     * @param req 查询条件
     * @return 集合
     */
    public List<GetDailyHarmlessReportResp> selectDailyHarmlessReport(GetDailyHarmlessReportReq req);

    /**
     * 查询生产检疫检验  2025-10-11
     *
     *
     * @return 集合
     */
    public List<ProduceCheckDTO> getProduceCheck(@Param("entranceBatchId") Long entranceBatchId);

    /**
     * 生猪产品出场情况表  2025-10-12
     *
     * @param req 查询条件
     * @return 集合
     */
    public List<GetDailyOutputReportResp> selectDailyOutputReport(GetDailyOutputReportReq req);

    List<JsStockInfo> selectStockReport(@Param("startTime")Date startTime, @Param("endTime")Date endTime);

    List<GetZhaoHuiResp> getZhaoHuiReport(@Param("startTime")Date startTime, @Param("endTime") Date endTime,@Param("animalType")String animalType);

    List<GetZaiQianResp> getZaiQianReport(@Param("startTime") Date startTime,@Param("endTime") Date endTime,@Param("animalType")String animalType);

    List<GetYangPinResp> getYangPinReport(@Param("startTime")Date startTime, @Param("endTime")Date endTime);

    List<GetEnvCheck> getProect();

    List<JingYangPinResp> getDaiZaiReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime);

    List<RunChagnResp> getRuChangReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime ,@Param("animalType")String animalType);

    List<ChuChagnResp> getChuChangReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime);

    List<GetZhuanYunReportResp> getZhuanYunReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime);

    List<FuJianResp> getFuJianReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime);

    List<ZaiHouResp> getZaiHouReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime,@Param("animalType")String animalType);

    List<XunChaResp>   selectXunChaReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime);

    List<XunChaDel> selectXunChaDelReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime);

    List<GysResp> gysReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime);

    List<TuZaiShengChanResp> tuzaiShengChanReport(@Param("startTime")Date startTime,  @Param("endTime")Date endTime,@Param("animalType")String animalType);
}
